#!usr/local/bin/perl

$INLIST1 = $ARGV[0];
$INLIST2 = $ARGV[1];

open(INLIST1,"$INLIST1");
open(INLIST2,"$INLIST2");

$OUTLIST1 = "blank.gml";

open(OUTLIST1,">../Output/$OUTLIST1");

print OUTLIST1 "graph [\n";
print OUTLIST1 "  axis_color \"#c0c0c0\"\n";
print OUTLIST1 "  chart_color_line_names \"1: Species 1/Genotype #1;2: Species 2/Genotype #2;3: Species 1/Genotype #1;4: Species 2/Genotype #2;\"\n";
print OUTLIST1 "  chart_colors \"0,0,0,255:0,0,0,255;192,192,192,255:0,0,0,255;0,0,0,255:0,0,0,255;64,64,64,255:0,0,0,255\"\n";
print OUTLIST1 "  connectPriorItems \"true\"\n";
print OUTLIST1 "  graphbackgroundcolor \"#ffffff\"\n";
print OUTLIST1 "  grid_color \"#c0c0c0\"\n";
print OUTLIST1 "  node_axisWidth 1.0\n";
print OUTLIST1 "  node_categoryBackgroundColorA \"#e1ffff\"\n";
print OUTLIST1 "  node_categoryBackgroundColorB \"#000000\"\n";
print OUTLIST1 "  node_categoryBackgroundColorC \"#ffffe1\"\n";
print OUTLIST1 "  node_categoryBackgroundColorIndexA -1\n";
print OUTLIST1 "  node_categoryBackgroundColorIndexC -1\n";
print OUTLIST1 "  node_chartShapeSize 6.0\n";
print OUTLIST1 "  node_chartStdDevLineWidth 4.0\n";
print OUTLIST1 "  node_chartStdDevTopWidth 10.0\n";
print OUTLIST1 "  node_gridWidth 0.5\n";
print OUTLIST1 "  node_halfErrorBar \"false\"\n";
print OUTLIST1 "  node_lineChartFillTimeGaps \"true\"\n";
print OUTLIST1 "  node_lineChartShowLines \"true\"\n";
print OUTLIST1 "  node_lineChartShowShapes \"true\"\n";
print OUTLIST1 "  node_lineChartShowStdDev \"false\"\n";
print OUTLIST1 "  node_lineChartShowStdDevRangeLine \"true\"\n";
print OUTLIST1 "  node_outlineBorderWidth 4.0\n";
print OUTLIST1 "  node_plotAxisFontSize 30\n";
print OUTLIST1 "  node_plotAxisRotation 0.0\n";
print OUTLIST1 "  node_plotAxisSteps 1.0\n";
print OUTLIST1 "  node_plotOrientationHor \"true\"\n";
print OUTLIST1 "  node_removeEmptyConditions \"false\"\n";
print OUTLIST1 "  node_showCategoryAxis \"false\"\n";
print OUTLIST1 "  node_showGridCategory \"true\"\n";
print OUTLIST1 "  node_showGridRange \"false\"\n";
print OUTLIST1 "  node_showRangeAxis \"false\"\n";
print OUTLIST1 "  node_usePieScale \"true\"\n";
print OUTLIST1 "  node_useStdErr \"false\"\n";
print OUTLIST1 "  ttestCircleSize 10.0\n";
print OUTLIST1 "  directed 1\n";


$NDA = 0;
while(<INLIST1>) {
chomp;
@ipartINLIST1 = split(/\t/);
push(@KEGG,$ipartINLIST1[0]);
$compname{$ipartINLIST1[0]} = $ipartINLIST1[1];
$Inchi{$ipartINLIST1[0]} = $ipartINLIST1[2];
$CHEBI{$ipartINLIST1[0]} = $ipartINLIST1[3];
++$NDA;
$IDDA{$ipartINLIST1[0]} = $NDA;
}

$sqrtda = int(sqrt($NDA));
print "$sqrtda\n";
$NKEGGN = @KEGG;

for($i = 0; $i < $NKEGGN; ++$i) {

print "$i\n";

$heida = $i/$sqrtda;
$heida = int($heida);
$amaridan = $i%$sqrtda;
print "$amaridan\t$i\t$sqrtda\n";
$adheida = 300.0 + 230.0*$amaridan;
$adheida = int($adheida);
$adheida = sprintf("%.1f",$adheida);
$adwei = 300.0 + 330.0*$heida;
$adwei = int($adwei);
$adwei = sprintf("%.1f",$adwei);


#######################should be printed in gml###########################
print OUTLIST1 "  node [\n";
print OUTLIST1 "    id $IDDA{$KEGG[$i]}\n";
print OUTLIST1 "    zlevel -1\n";

print OUTLIST1 "    graphics [\n";
print OUTLIST1 "      x $adwei\n";
print OUTLIST1 "      y $adheida\n";
print OUTLIST1 "      w 120.0\n";
print OUTLIST1 "      h 120.0\n";
print OUTLIST1 "      fill \"#FFFFFF\"\n";
print OUTLIST1 "      outline \"#000000\"\n";
print OUTLIST1 "      frameThickness 1.0\n";
print OUTLIST1 "      gradient 0.0\n";
print OUTLIST1 "      opacity 1.0\n";
print OUTLIST1 "      rounding 5.0\n";
print OUTLIST1 "      type \"rectangle\"\n";
print OUTLIST1 "    ]\n";
print OUTLIST1 "    label \"$compname{$KEGG[$i]}\"\n";
print OUTLIST1 "    labelgraphics [\n";
print OUTLIST1 "      alignment \"center\"\n";
print OUTLIST1 "      anchor \"n\"\n";
print OUTLIST1 "      color \"#0033cc\"\n";
print OUTLIST1 "      fontName \"Arial Narrow\"\n";
print OUTLIST1 "      fontSize 34\n";
print OUTLIST1 "      fontStyle \"bold,italic\"\n";
print OUTLIST1 "      type \"text\"\n";
print OUTLIST1 "    ]\n";
print OUTLIST1 "    labelgraphics1 [\n";
print OUTLIST1 "      alignment \"center\"\n";
print OUTLIST1 "      anchor \"hidden\"\n";
print OUTLIST1 "      color \"#000000\"\n";
print OUTLIST1 "      fontName \"Arial\"\n";
print OUTLIST1 "      fontSize 12\n";
print OUTLIST1 "      fontStyle \"plain\"\n";
print OUTLIST1 "      position [\n";
print OUTLIST1 "        localAlign 0.0\n";
print OUTLIST1 "        relHor 0.0\n";
print OUTLIST1 "        relVert 0.0\n";
print OUTLIST1 "      ]\n";
print OUTLIST1 "      text \"(kegg:$KEGG[$i])(InChi:$Inchi{$KEGG[$i]})(CHEBI:$CHEBI{$KEGG[$i]})\"\n";
print OUTLIST1 "      type \"text\"\n";
print OUTLIST1 "    ]\n";
print OUTLIST1 "  ]\n";

####################################gml node end#######################################

}

$IdTHREE = 0;
while(<INLIST2>) {
chomp;
@ipartINLIST2 = split(/\t/);
$IdONE = $IDDA{$ipartINLIST2[0]};
$IdTWO = $IDDA{$ipartINLIST2[1]};

	if($IdONE ne "") {
		if($IdTWO ne "") {
		++$IdTHREE;
		print OUTLIST1 "  edge [\n";
		print OUTLIST1 "    id $IdTHREE\n";
		print OUTLIST1 "    source $IdONE\n";
		print OUTLIST1 "    target $IdTWO\n";
		print OUTLIST1 "    graphics [\n";
		print OUTLIST1 "      fill \"#000000\"\n";
		print OUTLIST1 "      outline \"#666666\"\n";
		print OUTLIST1 "      arrow \"none\"\n";
		print OUTLIST1 "      frameThickness 14.0\n";
		print OUTLIST1 "      gradient 0.0\n";
		print OUTLIST1 "      opacity 0.4\n";
		print OUTLIST1 "      rounding 5.0\n";
		print OUTLIST1 "      thickness 1.0\n";
		print OUTLIST1 "    ]\n";
		print OUTLIST1 "  ]\n";
		}
	}
}



print OUTLIST1 "]\n";