#-------------------------------------------------------------------------------
# Name:        Merger.py
# Purpose:GML?????????????????????
#
# Author:      Fumio Matsuda
#
# Created:     30/07/2016
# Copyright:   (c) Fumio Matsuda 2016
# Licence:     <your licence>
#-------------------------------------------------------------------------------
import re
def main():
    pass

import sys	
argv = sys.argv[1:]	
	
if __name__ == '__main__':

    #
    # resize node rectangle
    # yes 1, no 0
    #
    flag_resize = 0

    gml_filename = argv[0]
    #shimadzu_gadget_filename = "Table_for_Area_Ratio_GCMS_blanktest.txt"
    shimadzu_gadget_filename = argv[1]
    output_filename = '../Output/output.gml'

    output_text = ""

    iddic = {}
    column_number_to_group = {}
    group_order = []
    group_to_column_number = {}
    data_structure = {}
    sample_id = 0
    with open(shimadzu_gadget_filename, 'r') as f:
        import csv
        idnumber = 1
        reader = csv.reader(f, delimiter='\t')
        for i,row in enumerate(reader):
            if i == 0:#first row is header
                header = row[:] # copy
            elif i == 1:# From second row, number of id columns were obtained.

                for i, symbol in enumerate(row):
                    if symbol == "*":
                        idnumber = idnumber + 1
                labels = header[idnumber :] #from idnumber h column to last column
                print(labels)
                ids = header[1:idnumber]
                print(ids)
                for j, label in enumerate(labels):
#                    print(labels)

#updated on 20170511 to handle column name without :
                    if re.compile(":").search(label):
                        group, filename = label.split(":")
                    else:
                        group = label
#update end
						
                    if group not in group_order:
                        group_order.append(str(group))
                    column_number_to_group[j] = str(str(group))
                for group in group_order:
                    group_to_column_number[group] = [i for i in column_number_to_group.keys() if column_number_to_group[i] == group]

            elif not re.search(r"^\(", row[0]):
                compound_name = row[0]
                data_structure[compound_name] = {'experiment':{}, 'group_order': group_order[:] }
                for i, id in enumerate(ids):
                    data_structure[compound_name][id]= row[i + 1]
                # Data part
                data = [i for i in row[idnumber:]]
                #data_structure[compound_name] = {'kegg': kegg, 'inchi': inchi, 'chebi': chebi, 'experiment':{}, 'group_order': group_order[:] }
                def sd(x):
                    ave = sum(x)/len(x)
                    var = sum([(v - ave)**2.0 for v in x])**0.5
                    return(var)
                for group in group_order:
                    sample_id = sample_id + 1
                    sample_data_original = [data[i] for i in group_to_column_number[group]]
                    #remode blank cells
                    #
                    sample_data_temp = [i for i in sample_data_original if i != ""]
                    sample_data = [float(i) for i in sample_data_temp if i != "#N/A"]

                    if len(sample_data) == 0:
                        sample_data = [0.0]

                    data_structure[compound_name]['experiment'][group] = {
                    'sample_id': sample_id,
                    'genotype': group,
                    'time': "1",
                    'unit': "relative",
                    'max': max(sample_data),
                    'min': min(sample_data),
                    'replicates': len(group_to_column_number[group]),
                    'stdev': sd(sample_data),
                    'average': sum(sample_data)/len(sample_data),
                    'data': sample_data[:],
                    }
                    #print data_structure[compound_name]
    #print group_to_column_number
    #print labels
    #print ids
    #print header


    pattern_node = r"  node \[\n"
    pattern_labelgraphics1 = r"    labelgraphics1 \[\n"
    pattern_close = r"    \]\n"
    pattern = r"      text "
    pattern_graphic = r"    graphics "
    current_node_label = "none"
    state = "none"
    output_text_temp = ""
    with open(gml_filename, 'r') as f:
        for i,row in enumerate(f):
            output_text_temp = output_text_temp + row
            if re.match(pattern_node, row):
                current_node_label = "none"
                #
                #
                #
                output_text = output_text + output_text_temp
                output_text_temp = ""

            if re.match(pattern_graphic, row):
                output_text_temp = output_text_temp + "      component \"chart2d_type3\"\n"
            if re.match(pattern_labelgraphics1, row):
                state = "start"

            if re.match(pattern_close, row):
                if state == "start":
                    if not current_node_label == "none":
                        #print str(current_node_label)
                        max_hit_id = ""
                        max_hit_num = 0
                        max_hit_kegg = ""
                        for id in data_structure:
                            hit_num = 0
                            hit_kegg = ""
                            for identifier in ids:
                                kegg = data_structure[id][identifier]
                                if kegg == "":
                                    continue
                                #print "checking", str(current_node_label), kegg
                                if current_node_label.find(kegg) >= 0:
                                    #print "OK!", str(current_node_label), kegg
                                    hit_num = hit_num + 1
                                    hit_kegg = str(kegg)


                            if max_hit_num < hit_num:
                                max_hit_id = str(id)
                                max_hit_kegg = hit_kegg
                                max_hit_num = hit_num
                        if max_hit_num > 0:
                            state = "none"

                            #print "OK!, max_hit_num, str(current_node_label), max_hit_kegg, max_hit_id"
                            #
                            # replace node size and shape
                            #
                            if flag_resize == 1:
                                output_text_temp = output_text_temp.replace('type "oval"', 'type "rectangle"')
                                output_text_temp = output_text_temp.replace('w 8.0', 'w 40.0')
                                output_text_temp = output_text_temp.replace('h 8.0', 'h 40.0')
                            #
                            # Add graph
                            #
                            output_text_temp = output_text_temp + "    mapping [\n"
                            output_text_temp = output_text_temp + "      measurementdata \"<substance id='"+max_hit_id+"' name='"+max_hit_kegg+"'>\n"
                            for order, group in enumerate(data_structure[max_hit_id]['group_order']):
                                temp = data_structure[max_hit_id]['experiment'][group]

                                sample_id=str(temp['sample_id'])
                                genotype=str(temp['genotype'])
                                time=str(temp['time'])
                                unit=str(temp['unit'])
                                tmax=str(temp['max'])
                                tmin=str(temp['min'])
                                replicates=str(temp['replicates'])
                                stdev=str(temp['stdev'])
                                average=str(temp['average'])
                                data = temp['data']
                                output_text_temp = output_text_temp + "<line experimentname='Test Experiment' coordinator='Test User' startdate='05/06/15 0:00' importdate='16/07/30 0:28' genotype='"+str(genotype)+"' id='"+str(order+1)+"' name='"+str(genotype)+"'>\n"
                                output_text_temp = output_text_temp + "<sample id='"+sample_id+"' time='"+time+"' unit='"+unit+"'>\n"
                                output_text_temp = output_text_temp + "<average max='"+tmax+"' min='"+tmin+"' replicates='"+replicates+"' stddev='"+stdev+"' unit='"+unit+"'>"+average+"</average>\n"
                                for i,value in enumerate(data):
                                    output_text_temp = output_text_temp + "<data replicates='"+str(i)+"' unit='"+unit+"'>"+str(value)+"</data>\n"
                                output_text_temp = output_text_temp + "</sample>\n"
                                output_text_temp = output_text_temp + "</line>\n"
                            output_text_temp = output_text_temp + "</substance>@\"\n"
                            output_text_temp = output_text_temp + "    ]\n"
                            #???????????
                            #break




            if re.match(pattern, row):
                rowtemp = row.replace("      text \"", "")
                rowtemp = rowtemp.replace("\"\n", "")
                current_node_label = current_node_label+str(rowtemp)
                #print str(rowtemp)
        output_text = output_text + output_text_temp

    #output filename
    f = open(output_filename, 'w')
    f.write(output_text)
    f.close() #

