if (!require("limma")) {
  source("http://bioconductor.org/biocLite.R") 
  biocLite("limma")
  library(limma)
}
if (!require("pcaMethods")) {
  source("http://bioconductor.org/biocLite.R") 
  biocLite("pcaMethods")
  library(pcaMethods)
}
if (!require("crmn")) {
  install.packages("crmn", dependencies = TRUE,repos="http://cran.rstudio.com/")
  library(crmn)
}
if (!require("metabolomics")) {
  install.packages("metabolomics", dependencies = TRUE,repos="http://cran.rstudio.com/")
  library(metabolomics)
}

args <- commandArgs()

INFILEDA <- as.matrix(read.table(args[6],sep="\t",header=T,row.names=1,check.names=F,quote=""))
INFILEDABC <- INFILEDA
namesda <- colnames(INFILEDA)
	if(colnames(INFILEDA)[3] == "KEGG_COMPOUND") {
	} else {
	write("File format error: \"KEGG_COMPOUND\" is required for Volcano plot analysis. However, there are no \"KEGG_COMPUND\" column in the data file.",file="../Output/log.txt")
	write("Process terminated.",file="../Output/log.txt",append=TRUE)
	q("no")
	}

tnc <- ncol(INFILEDABC)
#INFILEDABC <- INFILEDABC[,-tnc]

INFILEDABCBC <- INFILEDA
#INFILEDA <- INFILEDA[,-1]
#INFILEDA <- INFILEDA[,-1]
#INFILEDA <- INFILEDA[,-1]
#	if(is.matrix(INFILEDA) == TRUE) {
#	} else {
#	write("File format error: The number of samples in the data set is too small to do volcano plot analysis.",file="../Output/log.txt")
#	write("Process terminated.",file="../Output/log.txt",append=TRUE)
#	q("no")
#	}
INFILEDA <- INFILEDA[-1,]
#INFILEDA <- INFILEDA[-1,]

#print(INFILEDA)

#INFILEDABCBC <- INFILEDABCBC[-1,]
INFILEDABCBC <- INFILEDABCBC[-1,]
INFILEDABCBC <- INFILEDABCBC[,3]

#print(INFILEDABCBC)
#dim(INFILEDABCBC)

configda <- read.table("config.txt",header=F,sep="\t")

print(configda)

Control <- strsplit(as.character(configda[1,1]),",")
oneda <- length(Control[[1]])
	if(oneda >= 2) {
	} else {
	write("Error:The number of selected control samples is too small to do volcano plot analysis. Please select at least two control samples.",file="../Output/log.txt")
	write("Process terminated.",file="../Output/log.txt",append=TRUE)
	q("no")
	}
oneda <- rep(1,oneda)
print(Control)

Target <- strsplit(as.character(configda[2,1]),",")
twoda <- length(Target[[1]])
	if(twoda >= 2) {
	} else {
	write("Error:The number of selected target samples is too small to do volcano plot analysis. Please select at least two target samples.",file="../Output/log.txt")
	write("Process terminated.",file="../Output/log.txt",append=TRUE)
	q("no")
	}
twoda <- rep(2,twoda)
print(Target)

nclda <- length(Control[[1]])
for(i in 1:nclda) {
print(Control[[1]][i])
	if(INFILEDABC[1,Control[[1]][i]] == "*") {
 	write("Error:A column for compound ID is selected as Control sample. Please do not select ID column as Control sample.",file="../Output/log.txt")
	write("Process terminated.",file="../Output/log.txt",append=TRUE)
	q("no")
	}
}

nttda <- length(Target[[1]])
for(i in 1:nttda) {
print(Control[[1]][i])
	if(INFILEDABC[1,Target[[1]][i]] == "*") {
 	write("Error:A column for compound ID is selected as Target sample. Please do not select ID column as Target sample.",file="../Output/log.txt")
	write("Process terminated.",file="../Output/log.txt",append=TRUE)
	q("no")
	}
}

if(is.na(configda[3,1])) {
pvlth <- 0.05
} else {
pvlth <- as.numeric(as.vector(configda[3,1]))
}

if(is.na(configda[4,1])) {
flcth <- 2
} else {
flcth <- as.numeric(as.vector(configda[4,1]))
}

LGflcth <- log2(flcth)

Group <- c(oneda,twoda)
print(Group)

INFILEDA <- INFILEDA[,cbind(Control[[1]],Target[[1]])]
nnc <- ncol(INFILEDA)
nnr <- nrow(INFILEDA)

INFILEDA2 <- matrix(as.numeric(INFILEDA),ncol=nnc,nrow=nnr)
rownames(INFILEDA2) <- rownames(INFILEDA)
colnames(INFILEDA2) <- colnames(INFILEDA)
INFILEDA2 <- rbind(as.integer(Group),INFILEDA2)
print(INFILEDA2)

write.table(INFILEDA2,file="matrix.txt",sep="\t")

INFILEDA <- t(INFILEDA2)

DATALOGGED <- LogTransform(INFILEDA, base=2)$output

DATALOGGED <- replace(DATALOGGED, which(is.infinite(DATALOGGED) & (DATALOGGED < 0)), 0)

results <- try(TwoGroup(DATALOGGED)$output,silent=TRUE)
if(class(results) == "try-error") {
write("Error:Selected data (values in selected samples) are essentially constant. Thus, volcano plot analysis is not applicable for the data.",file="../Output/log.txt")
write("Process terminated.",file="../Output/log.txt",append=TRUE)
q("no")
} else {
}

results2 <- results

results[is.na(results)] <- 0

pval <- results[, 2]
fc <- results[, 4]

pdf("../Output/VolcanoPLOT.pdf",width=8.9,height=8.9)
VolcanoPlot(fc, pval, plimit = pvlth , cexlab = 0.45, fclimit = flcth , cexcexcutoff = 1.0 )
dev.off()

headerda <- cbind("compound Name","kegg id",t(colnames(results2)))
resultsF <- cbind(INFILEDABCBC[rownames(results2)],results2)
write.table(headerda,file="../Output/statistics_all.txt",col.names=F,sep="\t",row.names=F)
write.table(na.omit(resultsF),file="../Output/statistics_all.txt",col.names=F,sep="\t",quote=FALSE,row.names=T,append=TRUE)

sucess <- 0

resultsre <- data.frame(results2)
cond <- (resultsre[,2] < pvlth)
resultsre <- na.omit(resultsre[cond,])
cond <- order(resultsre[,2])
#print(cond)
	if(length(cond) == 0) {
	write(paste("Note: There are no metabolite with p-value lower than ",pvlth,". Therefore, \"statistics_for_metabolites_with_significance.txt\" and \"abundance_for_metabolites_with_significance.szf\" were not generated.",sep=""), file="../Output/log.txt")
	} else {
	sucess <- sucess + 1
	resultsre <- resultsre[cond,]
#	print(resultsre)
#	print(INFILEDABCBC[rownames(resultsre)])
#	print(INFILEDABCBC)
	resultsre <- cbind(INFILEDABCBC[rownames(resultsre)],resultsre)
	write.table(headerda,file="../Output/statistics_for_metabolites_with_significance.txt",col.names=F,sep="\t",row.names=F)
	write.table(resultsre,file="../Output/statistics_for_metabolites_with_significance.txt",col.names=F,sep="\t",quote=FALSE,row.names=T,append=TRUE)
	ms <- rownames(resultsre)
	ms <- INFILEDABC[ms,]
	write.table(t(c("compound names",colnames(INFILEDABC))),file="../Output/abundance_for_metabolites_with_significance.szf",col.names=F,sep="\t",row.names=F)
	write.table(t(INFILEDABC[1,]),file="../Output/abundance_for_metabolites_with_significance.szf",col.names=F,sep="\t",row.names=T,quote=FALSE,append=TRUE)
	write.table(ms,file="../Output/abundance_for_metabolites_with_significance.szf",col.names=F,sep="\t",quote=FALSE,row.names=T,append=TRUE)
	}
	
resultsre2 <- data.frame(results2)
cond2 <- (abs(resultsre2[,4]) > LGflcth)
resultsre2 <- na.omit(resultsre2[cond2,])
cond <- order(abs(resultsre2[,4]),decreasing=TRUE)
print(flcth)
#print(cond)
	if(length(cond) == 0) {
	write(paste("Note: There are no metabolite with fold change greater than ",flcth,".Therefore, \"statistics_for_metabolites_with_foldchange.txt\" and \"abundance_for_metabolites_with_foldchange.szf\" were not generated.",sep=""),"../Output/log.txt",append=TRUE)
	} else {
	sucess <- sucess + 1
	resultsre2 <- resultsre2[cond,]
	resultsre2 <- cbind(INFILEDABCBC[rownames(resultsre2)],resultsre2)
	write.table(headerda,file="../Output/statistics_for_metabolites_with_foldchange.txt",col.names=F,sep="\t",row.names=F)
	write.table(resultsre2,file="../Output/statistics_for_metabolites_with_foldchange.txt",col.names=F,sep="\t",quote=FALSE,row.names=T,append=TRUE)
	ms <- rownames(resultsre2)
	ms <- INFILEDABC[ms,]
	write.table(t(c("compound names",colnames(INFILEDABC))),file="../Output/abundance_for_metabolites_with_foldchange.szf",col.names=F,sep="\t",row.names=F)
	write.table(t(INFILEDABC[1,]),file="../Output/abundance_for_metabolites_with_foldchange.szf",col.names=F,sep="\t",row.names=T,quote=FALSE,append=TRUE)
	write.table(ms,file="../Output/abundance_for_metabolites_with_foldchange.szf",col.names=F,sep="\t",quote=FALSE,row.names=T,append=TRUE)
	}
	
resultsre3 <- data.frame(results2)
cond3 <- (abs(resultsre3[,4]) > LGflcth)
resultsre3 <- na.omit(resultsre3[cond3,])
cond3 <- (resultsre3[,2] < pvlth)
resultsre3 <- na.omit(resultsre3[cond3,])
cond3 <- order(resultsre3[,2])
	if(length(cond3) == 0) {
	write(paste("Note: There are no metabolite with fold change > ",flcth," and p-value < ",pvlth,". Therefore, \"statistics_for_metabolites_with_significance_and_foldchange.txt.\" and \"abundance_for_metabolites_with_significance_and_foldchange.szf\" were not generated.",sep=""),"../Output/log.txt",append=TRUE)
	} else {
	sucess <- sucess + 1
	#print(cond)
	resultsre3 <- resultsre3[cond3,]
	resultsre3 <- cbind(INFILEDABCBC[rownames(resultsre3)],resultsre3)
	write.table(headerda,file="../Output/statistics_for_metabolites_with_significance_and_foldchange.txt",col.names=F,sep="\t",row.names=F)
	write.table(resultsre3,file="../Output/statistics_for_metabolites_with_significance_and_foldchange.txt",quote=FALSE,col.names=F,sep="\t",row.names=T,append=TRUE)
	ms <- rownames(resultsre3)
	ms <- INFILEDABC[ms,]
	write.table(t(c("compound names",colnames(INFILEDABC))),file="../Output/abundance_for_metabolites_with_significance_and_foldchange.szf",col.names=F,sep="\t",row.names=F)
	write.table(t(INFILEDABC[1,]),file="../Output/abundance_for_metabolites_with_significance_and_foldchange.szf",col.names=F,sep="\t",row.names=T,quote=FALSE,append=TRUE)
	write.table(ms,file="../Output/abundance_for_metabolites_with_significance_and_foldchange.szf",col.names=F,sep="\t",quote=FALSE,row.names=T,append=TRUE)
	}
	
if(sucess == 3) {
write("All the processes successfully finished.",file="../Output/log.txt",append=T)
}

q("no")



